<!DOCTYPE HTML>
<html>
    <head>
        <meta charset="utf8">
        <title>Scratch Forum Post Statistics</title>
        <script src="Chart.min.js"></script>
        <link href="https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,400;0,700;1,400;1,700&display=swap" rel="stylesheet">
        <link href="userstyle.css" rel="stylesheet"> 
    </head>
    <body>
        <div id="top_text" style="margin: auto; text-align: center; margin-bottom: 5px;">
            Scratch Forum Leaderboards
        </div>
        <div id="top_text_2" style="margin: auto; text-align: center; margin-bottom: 15px;">
            ^^^^ (This is what it's called by the way) ^^^^
        </div>
        <div id="container">
            <div id="navigation">
                <a href="index.html?category=total">Forum Categories</a>
                <a href="user.html?user=CatsUnited">Users</a>
                <a href="https://my-ocular.jeffalo.net/login">Customise Profile (myocular)</a>
            </div>
        </div>
            <form action="" method="get">
                <input type="text" name="user" placeholder="Username"></input>
                <input type="submit" value="Go">
            </form>
            <div id="loadingtext">Loading<br><br></div>
            <div id="overview">
                <div id="overview-information">
                    <div id="overview-scratchinformation">

                    </div>
                    <div id="overview-postinformation">

                    </div>
                    <div id="overview-postinformationdescription">
                        <div id="overviewTotalPostsDescription">TOTAL POSTS</div>
                        <div id="overviewRankDescription">RANK</div>
                    </div>
                    <div id="overview-accountstatus">

                    </div>
                </div>
            </div>
            <div id="dateinformation">
                <div id="overview-postdates">

                </div>
            </div>
            <div id="container">
            <div class="graphtitletext">Post Distribution</div>
            <div id="piechart-container">
            <div id="piechart-area">
                <canvas id="piechart"></canvas>
            </div>
            </div>
            <div class="graphtitletext" id="PostOverTime">Post Count Over Time</div>
            <div id="historychart-container">
            <div id="historychart-area">
                <canvas id="historychart"></canvas>
            </div>
            </div>
            <br>
            <div id="content">
            </div>
        </div>
        <div id="footer">
            <div>Made by <a href="https://scratch.mit.edu/users/CatsUnited">CatsUnited</a></div>
            <div>Data from <a href="https://scratchdb.lefty.one/">ScratchDB</a> by <a href="https://scratch.mit.edu/users/DatOneLefty">DatOneLefty</a> and <a href="https://ocular.jeffalo.net/">Ocular</a> from <a href="https://scratch.mit.edu/users/Jeffalo">Jeffalo</a></div>
        </div>
        <div id="nowlaugh"></div>
        <div style="color: #FFF; text-align: center; font-family: 'Comic Sans MS', Comic Sans;">bottom text</div>
        <script>
            var chartCategories = [];
            var chartCounts = [];
            var chartColors = [];
            var historyPostCount = [];
            var historyPostDate = [];
            var historyPostRank = [];
            var monthList = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];

            var urlparams = new URLSearchParams(window.location.search);
            var selectedUsername = urlparams.get("user");
            if (selectedUsername == null)   {
                var selectedUsername = "CatsUnited";
            }

            function HSVtoRGB(h, s, v) {
                var r, g, b, i, f, p, q, t;
                if (arguments.length === 1) {
                    s = h.s, v = h.v, h = h.h;
                }
                i = Math.floor(h * 6);
                f = h * 6 - i;
                p = v * (1 - s);
                q = v * (1 - f * s);
                t = v * (1 - (1 - f) * s);
                switch (i % 6) {
                    case 0: r = v, g = t, b = p; break;
                    case 1: r = q, g = v, b = p; break;
                    case 2: r = p, g = v, b = t; break;
                    case 3: r = p, g = q, b = v; break;
                    case 4: r = t, g = p, b = v; break;
                    case 5: r = v, g = p, b = q; break;
                }
                return {
                    r: Math.round(r * 255),
                    g: Math.round(g * 255),
                    b: Math.round(b * 255)
                };
            }
            componentToHex = (c) => {
                var hex = c.toString(16);
                return hex.length == 1 ? `0${hex}` : hex;
            }
            RGBtoHEX = (r,g,b) => {
                return `${componentToHex(r)}${componentToHex(g)}${componentToHex(b)}`;
            }
            rankifier = (input) => {
                switch (input)  {
                    case 1:
                    case 21:
                    case 31:
                    case 41:
                    case 51:
                    case 61:
                    case 71:
                    case 81:
                    case 91:
                        return `${input}st`;
                        break;
                    case 2:
                    case 22:
                    case 32:
                    case 42:
                    case 52:
                    case 62:
                    case 72:
                    case 82:
                    case 92:
                        return `${input}nd`;
                        break;
                    case 3:
                    case 23:
                    case 33:
                    case 43:
                    case 53:
                    case 63:
                    case 73:
                    case 83:
                    case 93:
                        return `${input}rd`;
                        break;
                    case 69:
                        return `${input}th (nice)`;
                        break;
                    default:
                        return `${input}th`;
                    }
                }


            console.log(selectedUsername);
            fetch(`https://scratchdb.lefty.one/v2/forum/user/info/${selectedUsername}`)
                .then(res => res.json())
                .then(data => {
                    fetch(`https://scratchdb.lefty.one/v2/user/info/${selectedUsername}`)
                    .then(res1 => res1.json())
                    .then(otherdata => {
                        /* modify webpage title */
                        document.title = `${selectedUsername}'s Scratch Forums Statistics`;
                        /* delete loading text */
                        document.getElementById("loadingtext").remove();

                        /* render site layout */



                        /* title text */
                        titletext = document.createElement("a");
                        titletext.setAttribute("id", "titletext");
                        titletext.setAttribute("href", `https://scratch.mit.edu/users/${selectedUsername}`);
                        if (selectedUsername != null)   {titletext.appendChild(document.createTextNode(selectedUsername));}
                        document.getElementById("overview-information").appendChild(titletext);
                        /* overview total posts */
                        overviewTotalPosts = document.createElement("div");
                        overviewTotalPosts.setAttribute("id", "overviewTotalPosts");
                        console.log(data.counts.total.count);
                        overviewTotalPosts.appendChild(document.createTextNode(data.counts.total.count));
                        document.getElementById("overview-postinformation").appendChild(overviewTotalPosts);
                        /* overview rank */
                        overviewRank = document.createElement("div");
                        overviewRank.setAttribute("id", "overviewRank");
                        var ranking = rankifier(data.counts.total.rank);
                        overviewRank.appendChild(document.createTextNode(ranking));
                        document.getElementById("overview-postinformation").appendChild(overviewRank);
                        /* first posted */
                        var da = `FIRST POST: ${monthList[new Date(data.firstPost.time.posted).getMonth()]} ${rankifier(new Date(data.firstPost.time.posted).getDate())}, ${new Date(data.firstPost.time.posted).getFullYear()}`;  
                        firstPost = document.createElement("div");
                        firstPost.setAttribute("id", "firstPostInformation");
                        firstPost.appendChild(document.createTextNode(da));
                        document.getElementById("overview-postdates").appendChild(firstPost);
                        /* last posted */
                        var da = `LAST POST: ${monthList[new Date(data.lastPost.time.posted).getMonth()]} ${rankifier(new Date(data.lastPost.time.posted).getDate())}, ${new Date(data.lastPost.time.posted).getFullYear()}`;
                        lastPost = document.createElement("div");
                        lastPost.setAttribute("id", "lastPostInformation");
                        lastPost.appendChild(document.createTextNode(da));
                        document.getElementById("overview-postdates").appendChild(lastPost);
                        /* profile picture */
                        var profilepicture = document.createElement("img");
                        profilepicture.setAttribute("id", "profileimage");
                        profilepicture.setAttribute("src", `https://uploads.scratch.mit.edu/users/avatars/${otherdata.id}.png`);
                        document.getElementById("overview").appendChild(profilepicture);
                        /* pie graph setup */
                        for (let i in data.counts)    {
                            if (i == "total")   {
                                break;
                            }
                            console.log(i);
                            /* box for particular category */
                            user = document.createElement("div");
                            user.setAttribute("id", i);
                            user.setAttribute("class", "category");
                            var randomColor = HSVtoRGB(Math.random(), 0.5, Math.random() * (0.45-0.15) + 0.15);
                            user.setAttribute("style", "background-color: rgb(" + randomColor.r + "," + randomColor.g + "," + randomColor.b + "); padding: 5px " + window.innerWidth/50 + "px 5px " + window.innerWidth/50 + "px;");
                            document.getElementById("content").appendChild(user);
                            /* category name */
                            categorytext = document.createElement("a");
                            categorytext.setAttribute("id", i);
                            categorytext.setAttribute("class", "categorytext");
                            categorytext.setAttribute("href", "index.html?category=" + i);
                            if (i == "total")   {
                                categorytext.appendChild(document.createTextNode("Total Posts"));
                            } else  {
                                categorytext.appendChild(document.createTextNode(i));
                            }
                            document.getElementById(i).appendChild(categorytext);
                            /* right located content */
                            extrainfo = document.createElement("div");
                            extrainfo.setAttribute("id", "extrainfo" + i);
                            extrainfo.setAttribute("class", "extrainfo");
                            document.getElementById(i).appendChild(extrainfo);
                            /* category count */
                            categorycount = document.createElement("div");
                            categorycount.setAttribute("id", i + " Post Count");
                            categorycount.setAttribute("class", "categorycount");
                            categorycount.appendChild(document.createTextNode(data.counts[i].count));
                            document.getElementById("extrainfo" + i).appendChild(categorycount);
                            /* category rank */
                            categoryrank = document.createElement("div");
                            categoryrank.setAttribute("id", i + " Ranking");
                            categoryrank.setAttribute("class", "categoryrank");
                            var ranking = rankifier(data.counts[i].rank);
                            categoryrank.appendChild(document.createTextNode(ranking));
                            document.getElementById("extrainfo" + i).appendChild(categoryrank);
                            /* category percentage */
                            fullpostcount = document.createElement("div");
                            fullpostcount.setAttribute("id", "totalposts" + i);
                            fullpostcount.setAttribute("class", "postcountpercentage");
                            var perecentageposts = Math.round(document.getElementById(i + " Post Count").innerHTML / data.counts.total.count * 100 * 100)/100;
                            fullpostcount.appendChild(document.createTextNode(perecentageposts + "% of posts"));
                            document.getElementById("extrainfo" + i).appendChild(fullpostcount);
                            /* chart colors */
                            chartCounts.push(categorycount.innerHTML);
                            chartCategories.push(categorytext.innerHTML);
                            randomColor = `#${RGBtoHEX(randomColor.r, randomColor.g, randomColor.b)}`;
                            chartColors.push(randomColor);
                        }
                        console.log(chartColors)
                        /* pie graph */
                        var config = {
                            type: 'pie',
                            data: {
                                datasets: [{
                                    data: chartCounts,
                                    backgroundColor: chartColors,
                                    label: 'Scratcher Posts'
                                }],
                                labels: chartCategories,
                            },
                            options: {
                                responsive: true,
                            },
                        };
                        var ctx = document.getElementById('piechart').getContext('2d');
                        window.myPie = new Chart(ctx, config);

                        /* post count history setup */
                        var firstDate = new Date(data.history[0].date);
                        var lastDate = new Date(data.history[data.history.length - 1].date);
                        console.log(lastDate - firstDate); // time in milliseconds
                        var dateMonthSeparation = (lastDate - firstDate) / 1000 / 60 / 60 / 24;
                        console.log(dateMonthSeparation);
                        var lessDayMonths = [];
                        var moreDayMonths = [];
                        for (let i in data.history)    {
                            var currentDate = new Date(data.history[i].date);
                            if (i > 0)  {var previousDate = new Date(data.history[i-1].date);}

                            /* enter in missing points */

                            if ( currentDate - previousDate > 2678400000) {
                                var monthgap = Math.floor((currentDate - previousDate) / 1000 / 60 / 60 / 24 / 30.438);
                                console.log(`bruh: ${currentDate - previousDate} ms (${monthgap} months)`);
                                console.log(currentDate)
                                console.log(previousDate)
                                var yearCompensation = 0;
                                for (j = 1; j < monthgap + (yearCompensation > 0); j++)    {
                                    var calculatedMonth = new Date(previousDate).getMonth() + (1 + j);
                                    if (calculatedMonth - (yearCompensation * 12) == 13)   {
                                        yearCompensation++
                                    }
                                    console.log(j);
                                    console.log(`Month: ${calculatedMonth - (yearCompensation * 12)}`);
                                    console.log(`Year: ${yearCompensation}`)
                                    historyPostCount.push(data.history[i-1].value);
                                    historyPostDate.push(`${calculatedMonth - (yearCompensation * 12)}/${new Date(previousDate).getFullYear() + yearCompensation}`);
                                }
                            }

                            historyPostCount.push(data.history[i].value);
                            historyPostDate.push(`${new Date(data.history[i].date).getMonth() + 1}/${new Date(data.history[i].date).getFullYear()}`);
                        }
                        var currentTime = new Date()

                        /* post count history line graph */

                        var ctx = document.getElementById('historychart').getContext('2d');
                        window.lineChart = new Chart(ctx, {
                                type: 'line',
                                data: {
                                    labels: historyPostDate,
                                    datasets: [{
                                        label: `${selectedUsername}`,
                                        backgroundColor: "#EEEEEE",
                                        borderColor: "#FF0000",
                                        data: historyPostCount,
                                        fill: false,
                                        lineTension: 0,
                                    }]
                                },
                                options: {
                                    responsive: true,
                                    title: {
                                        display: true,
                                        text: 'Post Count Over Time'
                                    },
                                    tooltips: {
                                        mode: 'index',
                                        intersect: false,
                                    },
                                    hover: {
                                        mode: 'nearest',
                                        intersect: true
                                    },
                                    scales: {
                                        x: {
                                            display: true,
                                            scaleLabel: {
                                                display: true,
                                                labelString: 'Date'
                                            }
                                        },
                                        y: {
                                            display: true,
                                            scaleLabel: {
                                                display: true,
                                                labelString: 'Posts'
                                            }
                                        }
                                    }
                                }
                            });


                        /* user customised stuff */
                        fetch(`https://my-ocular.jeffalo.net/api/user/${selectedUsername}`)
                            .then(res2 => res2.json())
                            .then(userdata => {
                                /* scratcher/scratch team */
                                var scratcher = document.createElement("div");
                                scratcher.setAttribute("id", "accountstatus")
                                var scratcherstatus;
                                if (otherdata.status == "Scratch Team")    {
                                    scratcherstatus = scratcher.appendChild(document.createTextNode("SCRATCH TEAM"));
                                } else if (otherdata.status == "New Scratcher") {
                                    scratcherstatus = scratcher.appendChild(document.createTextNode("NEW SCRATCHER"));
                                } else  {
                                    scratcherstatus = scratcher.appendChild(document.createTextNode("SCRATCHER"));
                                }
                                    if (otherdata.username.toUpperCase() == userdata.name.toUpperCase())   {
                                        scratcher.removeChild(scratcherstatus);
                                        scratcher.appendChild(document.createTextNode(userdata.status));
                                    }
                                document.getElementById("overview-accountstatus").appendChild(scratcher);
                                /* custom overview color code */
                                    if (otherdata.username.toUpperCase() == userdata.name.toUpperCase())   {
                                        document.getElementById("overview").setAttribute("style", "background-color:" + userdata.color);
                                        document.getElementById("dateinformation").setAttribute("style", "background-color:" + userdata.color);
                                    }
                            })
                        /* end user customised stuff */
                        if (selectedUsername == "DatOneLefty")    {
                            funny = document.createElement("img");
                            funny.setAttribute("src", "linus.jpg");
                            document.getElementById("nowlaugh").appendChild(funny);
                        } else if (selectedUsername == "Jeffalo")   {
                            funny = document.createElement("div")
                            funny.appendChild(document.createTextNode("ha pranked you trying to xss this page that's a not gaming moment Jeffalo ha pranked"));
                            document.getElementById("nowlaugh").appendChild(funny);
                        }
                    })
                })
                .catch(function(){
                    alert(`https://scratchdb.lefty.one/v2/forum/user/info/${selectedUsername} failed to load D:`);
                });

                
        </script>
    </body>
</html>